<template>
  <el-dialog
    class="modify-black-item"
    :visible.sync="modalIsShow"
    :title="title"
    top="10vh"
    width="600px"
    :close-on-click-modal="false"
    :close-on-press-escape="false"
    append-to-body
    @open="visibleChange"
  >
    <el-form
      ref="modalFormComp"
      :model="modalForm"
      :rules="rules"
      label-width="120px"
    >
      <el-form-item prop="softName" label="软件名称：">
        <el-input
          v-model.trim="modalForm.softName"
          placeholder="请输入软件名称"
          clearable
        ></el-input>
      </el-form-item>
      <el-form-item prop="processName" label="进程名称：">
        <el-input
          v-model.trim="modalForm.processName"
          placeholder="请输入进程名称"
          clearable
        ></el-input>
      </el-form-item>
    </el-form>
    <div slot="footer">
      <el-button type="primary" :disabled="isSubmit" @click="submit"
        >确认</el-button
      >
      <el-button @click="cancel">取消</el-button>
    </div>
  </el-dialog>
</template>

<script>
import { objAssign } from "@/utils/utils";
import { saveBlackItem } from "@/api/system";

const initModalForm = {
  id: null,
  softName: "",
  processName: "",
};

export default {
  name: "modifyBlackItem",
  props: {
    instance: {
      type: Object,
      default() {
        return {};
      },
    },
  },
  computed: {
    isEdit() {
      return !!this.instance.id;
    },
    title() {
      return (this.isEdit ? "编辑" : "新增") + "黑名单";
    },
  },
  data() {
    return {
      modalIsShow: false,
      isSubmit: false,
      modalForm: { ...initModalForm },
      rules: {
        softName: [
          {
            required: true,
            message: "请输入软件名称",
            trigger: "change",
          },
          {
            message: "软件名称不能超过100个字",
            max: 100,
            trigger: "change",
          },
        ],
        processName: [
          {
            required: true,
            message: "请输入进程名称",
            trigger: "change",
          },
          {
            message: "进程名称不能超过100个字",
            max: 100,
            trigger: "change",
          },
        ],
      },
    };
  },
  methods: {
    initData(val) {
      if (val.id) {
        this.modalForm = objAssign(initModalForm, val);
      } else {
        this.modalForm = { ...initModalForm };
      }
    },
    visibleChange() {
      this.initData(this.instance);
    },
    cancel() {
      this.modalIsShow = false;
    },
    open() {
      this.modalIsShow = true;
    },
    async submit() {
      const valid = await this.$refs.modalFormComp.validate().catch(() => {});
      if (!valid) return;

      if (this.isSubmit) return;
      this.isSubmit = true;
      let datas = { ...this.modalForm };
      const data = await saveBlackItem(datas).catch(() => {});
      this.isSubmit = false;

      if (!data) return;

      this.$message.success(this.title + "成功！");
      this.$emit("modified");
      this.cancel();
    },
  },
};
</script>
